package com.sun.org.apache.xml.internal.security.c14n;

import java.io.OutputStream;
import org.w3c.dom.Node;
import java.util.Set;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;
import java.io.IOException;
import javax.xml.parsers.ParserConfigurationException;
import org.w3c.dom.Document;
import org.xml.sax.InputSource;
import com.sun.org.apache.xml.internal.security.utils.XMLUtils;
import java.io.ByteArrayInputStream;

public abstract class CanonicalizerSpi
{
    protected boolean reset;
    protected boolean secureValidation;
    
    public CanonicalizerSpi() {
        this.reset = false;
    }
    
    public byte[] engineCanonicalize(byte[] buf) throws ParserConfigurationException, IOException, SAXException, CanonicalizationException {
        Document parse = null;
        try (final ByteArrayInputStream byteStream = new ByteArrayInputStream(buf)) {
            parse = XMLUtils.createDocumentBuilder(false, this.secureValidation).parse(new InputSource(byteStream));
        }
        return this.engineCanonicalizeSubTree(parse);
    }
    
    public byte[] engineCanonicalizeXPathNodeSet(NodeList xpathNodeSet) throws CanonicalizationException {
        return this.engineCanonicalizeXPathNodeSet(XMLUtils.convertNodelistToSet(xpathNodeSet));
    }
    
    public byte[] engineCanonicalizeXPathNodeSet(NodeList xpathNodeSet, String s) throws CanonicalizationException {
        return this.engineCanonicalizeXPathNodeSet(XMLUtils.convertNodelistToSet(xpathNodeSet), s);
    }
    
    public abstract String engineGetURI();
    
    public abstract boolean engineGetIncludeComments();
    
    public abstract byte[] engineCanonicalizeXPathNodeSet(Set<Node> p0) throws CanonicalizationException;
    
    public abstract byte[] engineCanonicalizeXPathNodeSet(Set<Node> p0, String p1) throws CanonicalizationException;
    
    public abstract byte[] engineCanonicalizeSubTree(Node p0) throws CanonicalizationException;
    
    public abstract byte[] engineCanonicalizeSubTree(Node p0, String p1) throws CanonicalizationException;
    
    public abstract byte[] engineCanonicalizeSubTree(Node p0, String p1, boolean p2) throws CanonicalizationException;
    
    public abstract void setWriter(OutputStream p0);
    
    public boolean isSecureValidation() {
        return this.secureValidation;
    }
    
    public void setSecureValidation(boolean secureValidation) {
        this.secureValidation = secureValidation;
    }
}
